#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include <iterator>
#include "plugin.hpp"

extern PluginStartupInfo startupInfo;
extern const GUID MainGuid;

void errorMsg(const wchar_t *msg)
{
  const wchar_t *msgItems[]={L"Error", L"", L"Ok"};
  msgItems[1] = msg;
  startupInfo.Message(&MainGuid,
                      &__uuidof(struct __declspec(uuid("{180E557A-4431-45C5-9735-A04379FA11C1}")) TMsgGuid),
                      FMSG_WARNING, NULL,
                      msgItems,
                      std::size(msgItems), 1);
}

void debugMsg(const wchar_t *msg, int arg)
{
  const wchar_t *msgItems[]={L"Debug", L"", L"", L"Ok"};
  wchar_t line2[40];
  wsprintfW(line2, L"%d   0x%x", arg, arg);
  msgItems[1] = msg;
  msgItems[2] = line2;
  startupInfo.Message(&MainGuid,
                      &__uuidof(struct __declspec(uuid("{D4F35308-21B6-474E-9B26-FC0049C9A958}")) TMsgGuid),
                      FMSG_WARNING,
                      NULL,
                      msgItems,
                      std::size(msgItems), 1);
}
