#ifndef DETECTOR_HPP
#define DETECTOR_HPP

#include <windows.h>
#include "types.hpp"

struct FormatInfo
{
  BYTE    type;
  int     size;
  int     start;
  int     noSecs;

  BYTE    signature[32];
  WORD    signatureOffset;
  DWORD   signatureMask;
  BYTE    signatureSize;

  WORD    commentOffset;
  BYTE    commentSize;
  
  BYTE    specialChar;
  BYTE    newType;
  bool    skipHeader;
  wchar_t*   description;
};

class Detector
{
  public:
    Detector(const wchar_t *iniFilePath, const wchar_t* path);
    ~Detector();

    //  0xFF    
    BYTE  detect       (const SCLHdr& hdr, const BYTE* secs, int size, wchar_t* comment);
    
    void  specialChar  (BYTE n, wchar_t *pos);
    void  getType      (BYTE n, wchar_t *pos);
    bool  getSkipHeader(BYTE n);
    //  0, 
    //    
    const wchar_t* description  (BYTE n);
  private:
    BYTE       noFormats;
    FormatInfo formats[255];
};

#endif
