#ifndef types_hpp
#define types_hpp

enum FileType { FMT_SCL, FMT_HOBETA, FMT_PLAIN };

const int sectorSize = 0x100;
#pragma pack(push, 1)

//    SCL
struct SCLHdr
{
    char name[8];
    char type;
    WORD start;
    WORD size;
    BYTE noSecs;
};

//    TRD
struct FileHdr : SCLHdr
{
  BYTE sec;
  BYTE trk;
};

struct HoHdr
{
  char name[8];
  char type;
  union
  {
      WORD start;
      struct
      {
          char type1;
          char type2;
      };
  };
  WORD size;
  BYTE reserved;
  BYTE noSecs;
  WORD checkSum;
};

#pragma pack(pop)

#endif
