#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <algorithm>

#include "plugin.hpp"
#include "types.hpp"
#include "tools.hpp"
#include "tools_xlook.hpp"

void makeTrDosName(wchar_t *dest, const BYTE* hdr)
{
    *dest++ = L'[';
    for(int i = 0; i < 8; ++i) *dest++ = hdr[i] ? Cp866ToUcs2(hdr[i]) : L' ';

    *dest++ = L'.';

    BYTE ch1, ch2, ch3;
    ch1 = hdr[8];
    ch2 = hdr[9];
    ch3 = hdr[10];

    if(isEnAlphaNum(ch1) &&
        isEnAlphaNum(ch2) &&
        isEnAlphaNum(ch3))
    {
        *dest++ = ch1;
        *dest++ = ch2;
        *dest++ = ch3;
    }
    else
    {
        *dest++ = ch1 ? ch1 : L' ';
    }
    *dest++ = L']';
    *dest++ = 0;
}

