#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <algorithm>
#include "plugin.hpp"

#include "types.hpp"
#include "types_scl.hpp"
#include "tools.hpp"
#include "tools_scl.hpp"
#include "lang.hpp"

DWORD copySectors(HANDLE to, HANDLE from, int noSecs)
{
  DWORD noBytesWritten, noBytesRead;
  DWORD checkSum = 0;
  BYTE  sector[sectorSize];
  while(noSecs--)
  {
    ZeroMemory(sector, sectorSize);
    ReadFile (from, sector, sectorSize, &noBytesRead, NULL);
    WriteFile(to,   sector, sectorSize, &noBytesWritten, NULL);
    checkSum += calculateCheckSum(sector, sectorSize);
  }
  return checkSum;
}

bool isSCLFull(int no_files, int no_add_files, HANDLE file)
{
  if(no_files + no_add_files > 255)
  {
    const wchar_t *msgItems[4];
    msgItems[0] = GetMsg(MError);
    msgItems[1] = GetMsg(MTooBig1);
    msgItems[2] = GetMsg(MTooBig2);
    msgItems[3] = GetMsg(MOk);
    
    messageBox(FMSG_WARNING, msgItems, std::size(msgItems), 1);
    CloseHandle(file);
    return true;
  }
  return false;
}

void messageBoxDetectorIniCantOpen()
{
    const wchar_t * const msgItems[]{ GetMsg(MxPluginWarning), GetMsg(MCanNotOpenINI), GetMsg(MOk) };
    messageBox(FMSG_WARNING /*| FMSG_DOWN*/, msgItems, std::size(msgItems), 1);
}

void messageBoxDetectorIniError()
{
    const wchar_t * const msgItems[]{ GetMsg(MxPluginWarning), GetMsg(MINIError), GetMsg(MOk) };
    messageBox(FMSG_WARNING/* | FMSG_DOWN*/, msgItems, std::size(msgItems), 1);
}
