#ifndef MANAGER_HPP
#define MANAGER_HPP

class Manager
{
  public:
    Manager(const wchar_t* fileName);
    ~Manager();
    void GetOpenPanelInfo(struct OpenPanelInfo *Info);

    int  getFindData      (struct PluginPanelItem **pPanelItem, size_t *pNoItems, int opMode);
    void freeFindData     (struct PluginPanelItem *panelItem,   int  noItems);
    int  getFiles         (struct PluginPanelItem *panelItem, int noItems, int move, const wchar_t *destPath, int opMode);
  private:
    wchar_t            hostFileName[260];
    HANDLE          hostFile;
    WIN32_FIND_DATAW lastModifed;
    BYTE            noFiles;

    ZipedFileHdr    files  [255];
    ExtFileHdr      pcFiles[255];

    int   noVolumes;
    DWORD volumeSize[10];
    wchar_t* volumeName[10];
    int   volumeNum;

    bool openHostFile (void);
    void closeHostFile(void);

    bool readInfo     (void);
    void makePCNames  (void);

    bool extractFile  (int fNum, BYTE* buffer, int size);

    HANDLE open      (int fNum);
    bool   read      (void* buf, WORD size);
    bool   setPointer(DWORD offset);
};

#endif
